unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, AIUnit, ExtCtrls, Spin;

type
  TMain = class(TForm)
    GroupBox1: TGroupBox;
    Color1: TLabel;
    Color2: TLabel;
    Color3: TLabel;
    Color4: TLabel;
    ColorSelector1: TPopupMenu;
    Red1: TMenuItem;
    Violet1: TMenuItem;
    Blue1: TMenuItem;
    Green1: TMenuItem;
    Yellow1: TMenuItem;
    Olive1: TMenuItem;
    ColorSelector2: TPopupMenu;
    Red2: TMenuItem;
    Violet2: TMenuItem;
    Blue2: TMenuItem;
    Green2: TMenuItem;
    Yellow2: TMenuItem;
    Olive2: TMenuItem;
    ColorSelector3: TPopupMenu;
    Red3: TMenuItem;
    Violet3: TMenuItem;
    Blue3: TMenuItem;
    Green3: TMenuItem;
    Yellow3: TMenuItem;
    Olive3: TMenuItem;
    ColorSelector4: TPopupMenu;
    Red4: TMenuItem;
    Violet4: TMenuItem;
    Blue4: TMenuItem;
    Green4: TMenuItem;
    Yellow4: TMenuItem;
    Olive4: TMenuItem;
    GroupBox2: TGroupBox;
    Guess1: TLabel;
    Guess2: TLabel;
    Guess3: TLabel;
    Guess4: TLabel;
    StartStopBtn: TButton;
    AITimer: TTimer;
    Label2: TLabel;
    GenerationsBox: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    AISpeedBox: TSpinEdit;
    Label1: TLabel;
    CurrentChromoBox: TEdit;
    GroupBox3: TGroupBox;
    Label3: TLabel;
    TotalFitnessBox: TEdit;
    Label4: TLabel;
    AverageFitnessBox: TEdit;
    PerfectScoreBox: TCheckBox;
    Label7: TLabel;
    PopulationBox: TEdit;
    RandomizeColorsBox: TCheckBox;
    RandomizeColorsIntervalBox: TSpinEdit;
    Label8: TLabel;
    RandomizeColorsBtn: TButton;
    procedure Red1Click(Sender: TObject);
    procedure Violet1Click(Sender: TObject);
    procedure Blue1Click(Sender: TObject);
    procedure Green1Click(Sender: TObject);
    procedure Yellow1Click(Sender: TObject);
    procedure Olive1Click(Sender: TObject);
    procedure Red2Click(Sender: TObject);
    procedure Violet2Click(Sender: TObject);
    procedure Blue2Click(Sender: TObject);
    procedure Green2Click(Sender: TObject);
    procedure Yellow2Click(Sender: TObject);
    procedure Olive2Click(Sender: TObject);
    procedure Red3Click(Sender: TObject);
    procedure Violet3Click(Sender: TObject);
    procedure Blue3Click(Sender: TObject);
    procedure Green3Click(Sender: TObject);
    procedure Yellow3Click(Sender: TObject);
    procedure Olive3Click(Sender: TObject);
    procedure Red4Click(Sender: TObject);
    procedure Violet4Click(Sender: TObject);
    procedure Blue4Click(Sender: TObject);
    procedure Green4Click(Sender: TObject);
    procedure Yellow4Click(Sender: TObject);
    procedure Olive4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure StartStopBtnClick(Sender: TObject);
    procedure AITimerTimer(Sender: TObject);
    procedure AISpeedBoxChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure RandomizeColorsBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
  MAX_Population = 20;
var
  Main: TMain;

  NNMap: Array[0 .. 1] of Integer;
  NN: Array[0 .. MAX_Population - 1] of TNeuralNet;
  Chromo: Array[0 .. MAX_Population - 1] of TChromosome;
  ChromoLength: Integer;

  NumberOfGenerations: LongInt;
  TotalFitness: Integer;

implementation

{$R *.DFM}

{-- Misc. Functions --}
procedure RandomizeInputColors;
var Decoder: Integer;
begin
     Decoder := Round(Random(5) + 1);
     case (Decoder) of
       1 : Main.Color1.Font.Color := clRed;
       2 : Main.Color1.Font.Color := clPurple;
       3 : Main.Color1.Font.Color := clBlue;
       4 : Main.Color1.Font.Color := clGreen;
       5 : Main.Color1.Font.Color := clYellow;
       6 : Main.Color1.Font.Color := clOlive;
     end;
     Decoder := Round(Random(5) + 1);
     case (Decoder) of
       1 : Main.Color2.Font.Color := clRed;
       2 : Main.Color2.Font.Color := clPurple;
       3 : Main.Color2.Font.Color := clBlue;
       4 : Main.Color2.Font.Color := clGreen;
       5 : Main.Color2.Font.Color := clYellow;
       6 : Main.Color2.Font.Color := clOlive;
     end;
     Decoder := Round(Random(5) + 1);
     case (Decoder) of
       1 : Main.Color3.Font.Color := clRed;
       2 : Main.Color3.Font.Color := clPurple;
       3 : Main.Color3.Font.Color := clBlue;
       4 : Main.Color3.Font.Color := clGreen;
       5 : Main.Color3.Font.Color := clYellow;
       6 : Main.Color3.Font.Color := clOlive;
     end;
     Decoder := Round(Random(5) + 1);
     case (Decoder) of
       1 : Main.Color4.Font.Color := clRed;
       2 : Main.Color4.Font.Color := clPurple;
       3 : Main.Color4.Font.Color := clBlue;
       4 : Main.Color4.Font.Color := clGreen;
       5 : Main.Color4.Font.Color := clYellow;
       6 : Main.Color4.Font.Color := clOlive;
     end;
end;


{ -- ColorSelector for Color1 -- }
procedure TMain.Red1Click(Sender: TObject);
begin
     Color1.Font.Color := clRed;
end;
procedure TMain.Violet1Click(Sender: TObject);
begin
     Color1.Font.Color := clPurple;
end;
procedure TMain.Blue1Click(Sender: TObject);
begin
     Color1.Font.Color := clBlue;
end;
procedure TMain.Green1Click(Sender: TObject);
begin
     Color1.Font.Color := clGreen;
end;
procedure TMain.Yellow1Click(Sender: TObject);
begin
     Color1.Font.Color := clYellow;
end;
procedure TMain.Olive1Click(Sender: TObject);
begin
     Color1.Font.Color := clOlive;
end;

{ -- ColorSelector for Color2 -- }
procedure TMain.Red2Click(Sender: TObject);
begin
     Color2.Font.Color := clRed;
end;
procedure TMain.Violet2Click(Sender: TObject);
begin
     Color2.Font.Color := clPurple;
end;
procedure TMain.Blue2Click(Sender: TObject);
begin
     Color2.Font.Color := clBlue;
end;
procedure TMain.Green2Click(Sender: TObject);
begin
     Color2.Font.Color := clGreen;
end;
procedure TMain.Yellow2Click(Sender: TObject);
begin
     Color2.Font.Color := clYellow;
end;
procedure TMain.Olive2Click(Sender: TObject);
begin
     Color2.Font.Color := clOlive;
end;

{ -- ColorSelector for Color3 -- }
procedure TMain.Red3Click(Sender: TObject);
begin
     Color3.Font.Color := clRed;
end;
procedure TMain.Violet3Click(Sender: TObject);
begin
     Color3.Font.Color := clPurple;
end;
procedure TMain.Blue3Click(Sender: TObject);
begin
     Color3.Font.Color := clBlue;
end;
procedure TMain.Green3Click(Sender: TObject);
begin
     Color3.Font.Color := clGreen;
end;
procedure TMain.Yellow3Click(Sender: TObject);
begin
     Color3.Font.Color := clYellow;
end;
procedure TMain.Olive3Click(Sender: TObject);
begin
     Color3.Font.Color := clOlive;
end;

{ -- ColorSelector for Color4 -- }
procedure TMain.Red4Click(Sender: TObject);
begin
     Color4.Font.Color := clRed;
end;
procedure TMain.Violet4Click(Sender: TObject);
begin
     Color4.Font.Color := clPurple;
end;
procedure TMain.Blue4Click(Sender: TObject);
begin
     Color4.Font.Color := clBlue;
end;
procedure TMain.Green4Click(Sender: TObject);
begin
     Color4.Font.Color := clGreen;
end;
procedure TMain.Yellow4Click(Sender: TObject);
begin
     Color4.Font.Color := clYellow;
end;
procedure TMain.Olive4Click(Sender: TObject);
begin
     Color4.Font.Color := clOlive;
end;


procedure TMain.FormCreate(Sender: TObject);
var i: Integer;
begin
     NumberOfGenerations := 0;
     TotalFitness := 0;
     PopulationBox.Text := IntToStr(MAX_Population);

     Randomize;

     NNMap[0] := 1;
     NNMap[1] := 12;
     for i := 0 to MAX_Population - 1 do
     begin
          NN[i] := TNeuralNet.Init(4, NNMap, True);
          ChromoLength := NN[i].GetNumberOfWeights;
          Chromo[i] := TChromosome.Init(ChromoLength);
     end;
end;
procedure TMain.FormDestroy(Sender: TObject);
var i: Integer;
begin
     for i := 0 to MAX_Population - 1 do
     begin
          NN[i].Kill;
          Chromo[i].DeInit;
     end;
end;


procedure TMain.StartStopBtnClick(Sender: TObject);
begin
     if (AITimer.Enabled) then
     begin
         AITimer.Enabled := False;
         StartStopBtn.Caption := 'Start AI';
         StartStopBtn.Font.Color := clMaroon;
     end
     else
     begin
         AITimer.Enabled := True;
         StartStopBtn.Caption := 'Stop AI';
         StartStopBtn.Font.Color := clGreen;
     end;
end;

procedure TMain.AITimerTimer(Sender: TObject);
var DataIN: Array[0 .. 3] of Real;
    DataOUT: Array[0 .. 11] of Real;
    Decoder: Array[0 .. 3] of Integer;
    i: Integer;
begin
     StartStopBtn.Tag := StartStopBtn.Tag + 1;
     CurrentChromoBox.Text := IntToStr(StartStopBtn.Tag);
     if (StartStopBtn.Tag > MAX_Population - 1) then
     begin
          {Increment Number Of Generations}
          inc(NumberOfGenerations);
          GenerationsBox.Text := IntToStr(NumberOfGenerations);
          StartStopBtn.Tag := 0;

          {Randomize Colors if Option Selected}
          if (RandomizeColorsBox.Checked) and (NumberOfGenerations mod RandomizeColorsIntervalBox.Value = 0) then
          RandomizeInputColors;

          {Update Fitness Average}
          TotalFitness := 0;
          for i := 0 to MAX_Population - 1 do
              TotalFitness := TotalFitness + NN[i].FitnessScore;
          TotalFitnessBox.Text   := IntToStr(TotalFitness);
          AverageFitnessBox.Text := FloatToStrF(TotalFitness / MAX_Population, ffFixed, 2, 2);

          GetChromosomes(NN, Chromo, ChromoLength);
          ApplyAlgorithm(Chromo, ChromoLength);
          PutChromosomes(NN, Chromo, ChromoLength);
     end;

     {Encode Colors}
     case (Color1.Font.Color) of
       clRed    : DataIN[0] := 0.1;
       clPurple : DataIN[0] := 0.2;
       clBlue   : DataIN[0] := 0.3;
       clGreen  : DataIN[0] := 0.4;
       clYellow : DataIN[0] := 0.5;
       clOlive  : DataIN[0] := 0.6;
     end;
     case (Color2.Font.Color) of
       clRed    : DataIN[1] := 0.1;
       clPurple : DataIN[1] := 0.2;
       clBlue   : DataIN[1] := 0.3;
       clGreen  : DataIN[1] := 0.4;
       clYellow : DataIN[1] := 0.5;
       clOlive  : DataIN[1] := 0.6;
     end;
     case (Color3.Font.Color) of
       clRed    : DataIN[2] := 0.1;
       clPurple : DataIN[2] := 0.2;
       clBlue   : DataIN[2] := 0.3;
       clGreen  : DataIN[2] := 0.4;
       clYellow : DataIN[2] := 0.5;
       clOlive  : DataIN[2] := 0.6;
     end;
     case (Color4.Font.Color) of
       clRed    : DataIN[3] := 0.1;
       clPurple : DataIN[3] := 0.2;
       clBlue   : DataIN[3] := 0.3;
       clGreen  : DataIN[3] := 0.4;
       clYellow : DataIN[3] := 0.5;
       clOlive  : DataIN[3] := 0.6;
     end;

     NN[StartStopBtn.Tag].Execute(DataIN, DataOUT);

     {Show Results}
     Decoder[0] := Round(DataOUT[0] + DataOUT[1] * 2 + DataOUT[2] * 4);
     Guess1.Caption := FloatToStr(DataOUT[0]) + FloatToStr(DataOUT[1]) + FloatToStr(DataOUT[2]);
     case (Decoder[0]) of
       1 : Guess1.Font.Color := clRed;
       2 : Guess1.Font.Color := clPurple;
       3 : Guess1.Font.Color := clBlue;
       4 : Guess1.Font.Color := clGreen;
       5 : Guess1.Font.Color := clYellow;
       6 : Guess1.Font.Color := clOlive;
     else
     begin
          Guess1.Font.Color := clBlack;
//          dec(NN[DoneBtn.Tag].FitnessScore);
     end;
     end;
     Decoder[1] := Round(DataOUT[3] + DataOUT[4] * 2 + DataOUT[5] * 4);
     Guess2.Caption := FloatToStr(DataOUT[3]) + FloatToStr(DataOUT[4]) + FloatToStr(DataOUT[5]);
     case (Decoder[1]) of
       1 : Guess2.Font.Color := clRed;
       2 : Guess2.Font.Color := clPurple;
       3 : Guess2.Font.Color := clBlue;
       4 : Guess2.Font.Color := clGreen;
       5 : Guess2.Font.Color := clYellow;
       6 : Guess2.Font.Color := clOlive;
     else
     begin
          Guess2.Font.Color := clBlack;
//          dec(NN[DoneBtn.Tag].FitnessScore);
     end;
     end;
     Decoder[2] := Round(DataOUT[6] + DataOUT[7] * 2 + DataOUT[8] * 4);
     Guess3.Caption := FloatToStr(DataOUT[6]) + FloatToStr(DataOUT[7]) + FloatToStr(DataOUT[8]);
     case (Decoder[2]) of
       1 : Guess3.Font.Color := clRed;
       2 : Guess3.Font.Color := clPurple;
       3 : Guess3.Font.Color := clBlue;
       4 : Guess3.Font.Color := clGreen;
       5 : Guess3.Font.Color := clYellow;
       6 : Guess3.Font.Color := clOlive;
     else
     begin
          Guess3.Font.Color := clBlack;
//          dec(NN[DoneBtn.Tag].FitnessScore);
     end;
     end;
     Decoder[3] := Round(DataOUT[9] + DataOUT[10] * 2 + DataOUT[11] * 4);
     Guess4.Caption := FloatToStr(DataOUT[9]) + FloatToStr(DataOUT[10]) + FloatToStr(DataOUT[11]);
     case (Decoder[3]) of
       1 : Guess4.Font.Color := clRed;
       2 : Guess4.Font.Color := clPurple;
       3 : Guess4.Font.Color := clBlue;
       4 : Guess4.Font.Color := clGreen;
       5 : Guess4.Font.Color := clYellow;
       6 : Guess4.Font.Color := clOlive;
     else
     begin
          Guess4.Font.Color := clBlack;
//          dec(NN[DoneBtn.Tag].FitnessScore);
     end;
     end;

     {Score Results}
     if (Color1.Font.Color = Guess1.Font.Color) then
        inc(NN[StartStopBtn.Tag].FitnessScore);
     if (Color2.Font.Color = Guess2.Font.Color) then
        inc(NN[StartStopBtn.Tag].FitnessScore);
     if (Color3.Font.Color = Guess3.Font.Color) then
        inc(NN[StartStopBtn.Tag].FitnessScore);
     if (Color4.Font.Color = Guess4.Font.Color) then
        inc(NN[StartStopBtn.Tag].FitnessScore);

     if (NN[StartStopBtn.Tag].FitnessScore = 4) then
        if (PerfectScoreBox.Checked) then
        begin
             if (TotalFitness = MAX_Population * 4) then
             begin
                  AITimer.Enabled := False;
                  ShowMessage('ALL Chromosomes found a Solution in ' +
                              IntToStr(NumberOfGenerations) + ' generations!');
                  StartStopBtn.Caption := 'Start AI';
                  StartStopBtn.Font.Color := clMaroon;
             end;
        end
        else
        begin
             AITimer.Enabled := False;
             ShowMessage('Chromosome' + IntToStr(StartStopBtn.Tag + 1) + ' found a Solution in ' +
                         IntToStr(NumberOfGenerations) + ' generations!');
             StartStopBtn.Caption := 'Start AI';
             StartStopBtn.Font.Color := clMaroon;
        end;
end;

procedure TMain.AISpeedBoxChange(Sender: TObject);
begin
     AITimer.Interval := AISpeedBox.Value;
end;

procedure TMain.RandomizeColorsBtnClick(Sender: TObject);
begin
     RandomizeInputColors;
end;

end.
